<?php
/**
 * 输入格式化组数
 * @param  array|string $data 数组
 */
function dump($data){
    echo '<pre>';
    print_r($data);
    echo '</pre>';
}


/*
 * 获取数组当前键值key所在数组中的位置
 * @param $data  循环数组
 * @param  $key   key变量名
 * @return $unm 返回当 key所在数组中的位置
 */
function getKeyMap($data,$key){
    $i = 0;
    foreach($data as $k=>$v){
        if($k == $key){
            return $i;
        }
        $i++;
    }
}


/*
 * 获取get,post参数
 * @param $name get/post参数名
 * @return $param 返回get/post参数值
 */
function input($name){
	$param = '';
	//post
	if(preg_match('/post./',$name)){
		$paramArr = explode('.',$name);
		if(empty($paramArr[1])){
			$param = $_POST;
		}else{
			isset($_POST[$paramArr[1]])?$param = $_POST[$paramArr[1]] : null;
		}
	}
	//get
	else if(preg_match('/get./',$name)){
		$paramArr = explode('.',$name);
		if(empty($paramArr[1])){
			$param = $_GET;
			array_shift($param);
		}else{
			isset($_GET[$paramArr[1]])?$param = $_GET[$paramArr[1]] : null;
			
		}
	}
	//post / get
	else{
		  $param = $_GET[$name];
		if(empty($param)){
		  $param = $_POST[$name];
		}
	}
	
	//数组不过滤
	if(is_array($param)){
		 return $param;
	}
	
	//过滤sql关键字
   $param = sprintf("%s",preg_replace('/\b(=|<|>|and|or|;|where|from|not|HAVING|select|script|i?frame|style|html|body|title|link|meta|object)\b/im','',$param));

   return $param;
}


/*
 * 获取当前项目配置,或指定路径配置文件
 * @param string $name 配置名
 * @param string $dir 配置文件路径
 * @return string|array $param 返回配置值
 */
function config($_name = '',$_dir=''){

    if(empty($_dir)){
			$appConfig = require APP_PATH.'/'.$GLOBALS['module'].'/config.php';
			$globalConfig = require ROOT_PATH.'/config/config.php';
			$_config = array_merge($globalConfig,$appConfig);
    }else{
        $_config = require $_dir;
    }

    if(empty($_name)){
        return $_config;
    }else{
        if(isset($_config[$_name])){
            return $_config[$_name];
        }
    }
}

/*
 * db助手函数
 * @param string   $tableName表名
 * @retrun  数据库链接对象
 */
function db($tableName){
    $db = new \blockphp\lib\Db();
    return $db::table($tableName);
}

/*
 * cache助手函数
 * @param string   $name 缓存名称
 * @param data  $value  缓存数据
 * @param int  $expire  缓存有效期 为空则永久缓存
 */

function cache($name,$value='',$expire=0){

    $cache = new \blockphp\lib\Cache();

    //删除
    if(!is_array($name) && $value === NULL){
        return $cache::rm($name);
    }

    //获取缓存
    if(!is_array($name) && empty($value)){
        return $cache::get($name);
    }
    //生成缓存
    if(!empty($value)){
        return $cache::set($name,$value,$expire);
    }
    //自定义配置
    if(is_array($name) && empty($value)){
        return $cache::connect($name);
    }

}


/**
 * PHP判断当前协议是否为 HTTPS
 */
function is_https() {
    if ( !empty($_SERVER['HTTPS']) && strtolower($_SERVER['HTTPS']) !== 'off') {
        return true;
    } elseif ( isset($_SERVER['HTTP_X_FORWARDED_PROTO']) && $_SERVER['HTTP_X_FORWARDED_PROTO'] === 'https' ) {
        return true;
    } elseif ( !empty($_SERVER['HTTP_FRONT_END_HTTPS']) && strtolower($_SERVER['HTTP_FRONT_END_HTTPS']) !== 'off') {
        return true;
    }
    return false;
}


/*
 * url助手函数
 * @param string  $url 地址
 * @param string  $param get参数
 * @param string  $hz 生成url后辍，默认为html
 * @param srting|bool 是否指定域名 trun为当前域名，可传二级域名前辍或完整域名
 */
function url($url='',$param='',$hz='html',$domain = null){
    $U = new \blockphp\lib\Url();
    return $U::build($url,$param,$hz,$domain);
}

/*
 * 判断是否是post请
 */
function is_post(){
    return $_SERVER['REQUEST_METHOD'] == 'POST' ? true : false;
}

/*
 * 判断是否是get请
 */
function is_get(){
    return $_SERVER['REQUEST_METHOD'] == 'GET' ? true : false;
}


/*
 * 加密函数
 * @param string $txt 需要加密的文本
 * @param string $key 密钥
 */
function lock($txt,$key='www.blockphp.com'){
    $chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-=+";
    $nh = rand(0,64);
    $ch = $chars[$nh];
    $mdKey = md5($key.$ch);
    $mdKey = substr($mdKey,$nh%8, $nh%8+7);
    $txt = base64_encode($txt);
    $tmp = '';
    $i=0;$j=0;$k = 0;
    for ($i=0; $i<strlen($txt); $i++) {
        $k = $k == strlen($mdKey) ? 0 : $k;
        $j = ($nh+strpos($chars,$txt[$i])+ord($mdKey[$k++]))%64;
        $tmp .= $chars[$j];
    }
    return urlencode($ch.$tmp);
}

/*
 * 解密函数
 * @param string $txt 需要解密的文本
 * @param string $key 密钥
 */
function unlock($txt,$key='www.blockphp.com'){
    $txt = urldecode($txt);
    $chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-=+";
    $ch = $txt[0];
    $nh = strpos($chars,$ch);
    $mdKey = md5($key.$ch);
    $mdKey = substr($mdKey,$nh%8, $nh%8+7);
    $txt = substr($txt,1);
    $tmp = '';
    $i=0;$j=0; $k = 0;
    for ($i=0; $i<strlen($txt); $i++) {
        $k = $k == strlen($mdKey) ? 0 : $k;
        $j = strpos($chars,$txt[$i])-$nh - ord($mdKey[$k++]);
        while ($j<0) $j+=64;
        $tmp .= $chars[$j];
    }
    return base64_decode($tmp);

}


/*
 * 不可逆加密函数
 * @param string $txt 需要解密的文本
 */
function hmac($string){
   return hash_hmac('md5', $string,'blockphp');
}






































