<?php
/*
 * 项目文件
 * 获取当前项目 模型，控制器 ，方法，参数，配置
 * 全局变量保存 $GLOBALS['module'],、$GLOBALS['controller'] ,$GLOBALS['action']，$GLOBALS['config']
 * 注册自动加载类
 * 执行项目方法
*/
namespace blockphp\lib;

class App
{

    public function run()
    {

        $this->appInfo(); //获取当前模块的模型、控制器、方法、参数
        $this -> registerAutoLoad(); //注册自动加载
        $this -> display();  //请求分发

    }

    //获取当前模块的模型、控制器、方法、参数
    public function appInfo()
    {


        //引入路由类，对 URI 进行处理
        require BLOCKPHP.'/lib/Route.php';
        $route = new \blockphp\lib\Route();
        $uri =  $route::setRoute($_SERVER['REQUEST_URI']);


        //去除get参数
        $_path = preg_replace('/\?.+$/','',$uri);
        //去除url后辍
        $_path = preg_replace('/\..+$/','',$_path);
        //模型-控制器-方法-get参数
        $_path = explode('/',trim($_path,'/'));
        empty($_path['0']) ? $GLOBALS['module'] = 'index': $GLOBALS['module'] = $_path['0']; //模型
        empty($_path['1']) ? $GLOBALS['controller'] = 'index': $GLOBALS['controller'] = $_path['1']; //控制器
        empty($_path['2']) ? $GLOBALS['action'] = 'index': $GLOBALS['action'] = $_path['2'];//方法
        $GLOBALS['config'] = config();

        //get参数
        if($_path>4){
            $_param = array_diff_key($_path,[0,1,2]);
            $_count = count($_param)+3;
            $i = 3;
            while($i<$_count){
                if(isset($_param[$i+1])){
                    //$GLOBALS['GET'][$_param[$i]]=$_param[$i+1];
                    $_GET[$_param[$i]]=$_param[$i+1];
                }
                $i=$i+2;
            }
        }
    }



    //注册自动加载
    public function registerAutoLoad()
    {

        spl_autoload_register([$this, 'autoload']);
    }

    public function autoload($_className)
    {
			if(!is_file(ROOT_PATH.'/'.$_className.'.php')){
				echo 'Error: '.ROOT_PATH.'/'.$_className.'.php'.' 文件不存在';
			}
			require_once(ROOT_PATH.'/'.$_className.'.php');
    }

    //请求分发
    public function display()
    {

        //设置utf-8编码
        header('Content-Type:text/html;charset=utf-8');
        $_conPath = "\app\\".$GLOBALS['module']."\controller\\".ucfirst($GLOBALS['controller']); //命名空间+控制
        $_action = $GLOBALS['action']; //方法名
        $_appCon = new $_conPath; //实例化控制器类
        $_appCon->$_action(); //执行方法


    }





}






















