<?php
/*
 * 公共控制器
*/

namespace blockphp\lib;
class Controller
{


    private $_vars = array();//模版变量数组
    public $db = null;  //数据库连接对象


    /* assign模版赋值方法
     * param $_name string or array
     * param $_value string
     * 支持$_name为数组，批量赋值
     */
    public function assign($_name='',$_value='')
    {
        if(is_array($_name) && $_value==''){
            foreach ($_name as $_key=>$_val){
                $this->_vars[$_key] = $_val;
            }
        }else{
            //$_var用于同步模板里的变量名
            if (isset($_name) && isset($_value)){
                $this->_vars[$_name] = $_value;
            } else {
                exit('ERROR：请设置模板变量');
            }
        }
    }

    //视图渲染方法
    public function view()
    {
        //判断是否开启缓冲区
        $cache = $GLOBALS['config']['request_cache'];
        $cache ? ob_start() : null;

        //载入assign赋值的变量
        foreach ($this->_vars as $_varsKey=>$_varsVal){
            $$_varsKey = $_varsVal;
        }


        //获取当前页面路径 $_SERVER['REQUEST_URI'],md5加密码生成字符串，取第0-2位字符，作为文件夹，取第2位至最后字符，作为文件名
        $_parFolder= substr(md5($_SERVER['REQUEST_URI']),0,2); //编译文件夹
        $_parName = substr(md5($_SERVER['REQUEST_URI']),2); //编译文件名
        $_parFolderPath = ROOT_PATH.'/runtime/temp/'.$_parFolder; //编译文件夹路径
        $_parFile = ROOT_PATH.'/runtime/temp/'.$_parFolder.'/'.$_parName.'.htm'; //编译文件路径

        $_cacheFolder= substr(md5($_SERVER['REQUEST_URI']),0,2); //缓存文件夹
        $_cacheName = substr(md5($_SERVER['REQUEST_URI']),2); //缓存文件名
        $_cacheFolderPath = ROOT_PATH.'/runtime/html/'.$_cacheFolder; //缓存文件夹路径
        $_cacheFile = ROOT_PATH.'/runtime/html/'.$_cacheFolder.'/'.$_cacheName.'.html'; //缓存文件路径

        //判断模板是否存在,模版默认路径，模型->view文件夹->控制器文件夹下->方法.htm
        $_tplFile = APP_PATH.'/'.$GLOBALS['module'].'/view/'.$GLOBALS['controller'].'/'.$GLOBALS['action'].'.htm';
        if (!file_exists($_tplFile)) {
            exit('ERROR：'.$_tplFile.' 模板文件不存在！');
        }

        //当第二次运行相同文件的时候，直接载入缓存文件，避开编译
        if($cache){
            //缓存文件和编译文件都要存在
            if (file_exists($_cacheFile) && file_exists($_parFile)){
                //判断模板文件是否修改过，判断编译文件是否修改过
                if (filemtime($_parFile) >= filemtime($_tplFile) && filemtime($_cacheFile) >= filemtime($_parFile)) {
                    //载入缓存文件
                    include $_cacheFile;
                    return;
                }
            }
        }


        //加载模版类
        $template =  new \blockphp\lib\Template();
        //实例化模板解析类
        $_parser = new \blockphp\lib\template\TagLib($_tplFile);
        //模版解析
        $_parser->compile($_parFile,$_parFolderPath);
        //载入编译文件
        include $_parFile;


        if($cache){
            //当cache下的缓存文件夹不存在时，生成文件夹
            is_dir($_cacheFolderPath)?null:mkdir($_cacheFolderPath,0777,true);
            //获取缓冲区内的数据，并且创建缓存文件
            file_put_contents($_cacheFile,ob_get_contents());
            //清除缓冲区(清除了编译文件加载的内容)
            ob_end_clean();
            //载入缓存文件
            include $_cacheFile;
        }


    }



    /**
     * Ajax方式返回数据到客户端
     * @access protected
     * @param mixed $data 要返回的数据
     * @param String $type AJAX返回数据格式
     * @return void
     */
    protected function ajaxReturn($data,$type='') {

        if(empty($type)) $type =  config('DEFAULT_AJAX_RETURN');
        if(strtoupper($type)=='JSON') {
            // 返回JSON数据格式到客户端 包含状态信息
            header('Content-Type:text/html; charset=utf-8');
            exit(json_encode($data));
        }elseif(strtoupper($type)=='XML'){
            // 返回xml格式数据
            header('Content-Type:text/xml; charset=utf-8');
            exit(xml_encode($data));
        }elseif(strtoupper($type)=='EVAL'){
            // 返回可执行的js脚本
            header('Content-Type:text/html; charset=utf-8');
            exit($data);
        }else{
            // TODO 增加其它格式
        }
    }





}

