<?php
//路由类

namespace blockphp\lib;

use http\Env\Request;

class Route
{
    public static $config; //路由配置
    public static $towDomain; //当前域名
    public static $http; //是否是https
    public static $module; //当前模型

    //获取路由配置
    public static function getConfig()
    {
        $appConfig = require APP_PATH.'/'.self::$module.'/config.php';
        $globalConfig = require ROOT_PATH.'/config/config.php';
        $config = array_merge($globalConfig,$appConfig);
        return $config['route'];
    }

    //获取规则
    public static function rule()
    {
        return require APP_PATH.'/route.php';
    }

    //路由url匹配替换成实际url
    public static function setRoute($uri)
    {
        //获取url地址信息
        self::getSever();

        $defUri = $uri;

        //路由配置
        $route = self::rule();
        $patten = array();

        //正则语句转换
        //:id  == (id\/\w+);
        //[:id]  == (id\/\w+){0,};
        foreach ($route as $k=>$v){
            if(preg_match_all('/:(\w+)/',$k,$res)){
                foreach ($res[1] as $rk => $rv){
                    $k = str_replace(':'.$rv,'('.$rv.'/\w+)',$k);
                }
                $k = str_replace('/','\/',$k);
                $k = str_replace('/[','/?',$k);
                $k = str_replace(']','{0,}',$k);
            }
            $patten[$k] = $v;
        }

        //正则匹配参数提取
        foreach ($patten as $key=>$val){

            if(preg_match('/'.$key.'/',$uri,$param)){
                array_shift($param);
                $param = implode('/',$param);

                if(is_array($val)){
                    $uri = '/'.$val[0].'/'.$param;
                    //需要在判断其它参数是否符合条件,待开发...
                }else{
                    $uri = '/'.$val.'/'.$param;
                }
            }

            //二级域名布属
            if($key == '__domain__'){
               foreach ($val as $dk=>$dv){
                   if($dk == self::$towDomain){
                       $uri = $dv.$uri;
                   }
               }
            }
        }

        //获取当前模型
        $model = explode('/',$uri)[1];
        empty($model)? $model='index': null;
        self::$module = $model;

        //判断是否开户路由
        $appConfig = self::getConfig();
        if(!$appConfig['url_route_on']){
            $uri =  $defUri;
        }
        return $uri;
    }

    //获取url地址信息
    public static function  getSever()
    {
        //是否是https
        if(is_https()){
            self::$http = 'https';
        }else{
            self::$http = 'http';
        }

        //当前二级域名
        self::$towDomain = explode('.',$_SERVER['HTTP_HOST'])[0];
    }


    //生成路由url
   public static function  buildUrl($url,$param){

       //获取url地址信息
       self::getSever();
       $defUri = $url; //url路径

       //路由配置
       $route = self::rule();

       $patten = array();

        //正则规则转换
        foreach ($route as $k=>$v){
            if($k !='__domain__'){ //非域名布属

               $arr = explode('/:',$k);
               $path = $arr[0];  //获取路径部分
               if(count($arr) == 1){  //获取参数部分
                   $p = '';
                   $patten[$path] = $v;
               }else{
                   array_shift($arr);
                   $p = ':'.implode('/:',$arr);
                   $patten[$path] = $v.'/'.$p;
               }
            }
        }


        //正则规则转换
		  $rule = array();
        foreach ($patten as $pk=>$pv){
            if(preg_match_all('/:(\w+)/',$pv,$content)){
                foreach ($content[1] as $ck => $cv){
                    $pv = str_replace(':'.$cv,'('.$cv.'/\w+)',$pv);
                }
                $pv = str_replace('/[','/?',$pv);
                $pv = str_replace(']','{0,}',$pv);
            }
            $pv = str_replace('/','\/',$pv);
            $rule[$pk] = $pv;

        }
		  
			$result = '';
			if(count($rule)>0){
				 //正则匹配
				  foreach ($rule as $rk=>$ru){
						if(preg_match('/'.$ru.'/',$url.$param)){
							 $result =  $rk.$param;
						}
				  }
			}
       
        return empty($result)? $url.$param: $result;

   }

}