<?php

/*
 * url生成类
 *
 */

namespace blockphp\lib;
use blockphp\lib\Route;

class Url
{
    /*
     * 生成url
     * @param string  $url 地址
     * @param string  $param get参数
     * @param string  $hz 生成url后辍，默认为html
     * @param srting|bool  $domain是否指定域名 trun为当前域名，可传二级域名前辍或完整域名
     */
    public static function build($url='',$param='',$hz='html',$domain = null)
    {
		 
        //模型，控制器，方法
		  $module = $GLOBALS['module'];
		  $controller = $GLOBALS['controller'];
		  $action = $GLOBALS['action'];
		  
        $url = explode('/',$url);
		  $count = count($url);
		  if($count == 1){
			  $module = $url[0];
		  }elseif($count == 2){
			  $controller = $url[0];  $action = $url[1];
		  }elseif($count > 2){
			  $module=$url[0];  $controller=$url[1];   $action=$url[2];
		  }
		  
        $url = $module.'/'.$controller.'/'.$action;
        if(!empty($param)){
				$temp  ='';
				foreach($param as $k=>$v){
					$temp .= '/'.$k.'/'.$v;
				}
				$param = $temp;
        }

        //域名
        is_https()?$http = 'https://':$http = 'http://';
        if($domain ===  true){
            $domain = $http.$_SERVER['HTTP_HOST'];
        }else if($domain){
            $arr = explode('.',$domain);
            if(count($arr)==1){
                $host = explode('.',$_SERVER['HTTP_HOST']);
                $host[0] = $domain;
                $domain = $http.implode('.',$host);
            }else{
                $domain = $http.$domain;
            }
        }

        //url后辍
        empty($hz)? $hz='.html': $hz = '.'.$hz;


        //判断是否开户路由,如果开启了，就执行路由处理
        $appConfig = require APP_PATH.'/'.$module.'/config.php';
        $globalConfig = require ROOT_PATH.'/config/config.php';
        $config = array_merge($globalConfig,$appConfig);


        if($config['route']['url_route_on']){
            $route = Route::buildUrl($url,$param);
        }else{
            $route = $url.$param;
        }


        //反回url
        $res = $domain.'/'.$route.$hz;
        return $res;
    }



}