<?php
namespace blockphp\lib\template;
//Parser标签库解析类
class Parser

{

    //普通变量解析
    public function parVar($content)
    {
        if(preg_match('/\{(\$.+)\}/',$content,$param)){
           $param = explode('.',$param[1]);
           $temp ='';
           foreach ($param as $k=>$v){
               if($k == 0){
                   $temp .=$v;
               }else{
                   if(is_numeric($v)){
                       $temp .="[".$v."]";
                   }else{
                       $temp .="['".$v."']";
                   }
               }
           }
        }
        $content = preg_replace('/\{\$.+\}/U',"<?php echo ".$temp.'; ?>',$content);

        return $content;
    }

    //模版继承解析
    public function parExtend($name,$tpl)
    {
        //继承的模版文件
        $ext_tpl = file_get_contents(APP_PATH.'/'.$GLOBALS['module'].'/view/'.$name.'.htm');

        //正则匹配内容
        if(preg_match_all('/\{part\s+name=[\'"](\w+)[\'"]\}([\s\S]*?)\{\/part\}/',$tpl,$param)){
            //获取模版文件 ，继承部份内容
            $names = $param[1];
            $values = $param[2];
            $content = array_combine($names,$values);

            //匹配替换继承模版各部份内容
            foreach ($content as $name=>$value){
                $patten = '/\{part\s+name=[\'"]'.$name.'[\'"]\}([\s\S]*?)\{\/part\}/';
                $ext_tpl = preg_replace($patten,$value,$ext_tpl);
            }
        }

        //清理继承模版 part 标签
        $ext_tpl = preg_replace('/\{part\s+name=[\'"]\w+[\'"]\}/','',$ext_tpl);
        $ext_tpl = preg_replace('/\{\/part\}/','',$ext_tpl);
        return $ext_tpl;
    }


    //全局字符串替换
    public function parReplaceStr($replaceArr,$tpl)
    {
       foreach ($replaceArr as $patten => $str){
           $tpl = preg_replace('/'.$patten.'/',$str,$tpl);
       }
        return $tpl;
    }

    //模版引入标签,默认模版路径指向当前模型下的view文件夹
    public function parTemplate($dirArr,$tpl)
    {
        foreach ($dirArr as $val){

            $file = file_get_contents(ROOT_PATH.$val);
            $patten = str_replace(['/','.'],['\/','\.'],$val);
            $tpl = preg_replace('/\{template\s+\"'.$patten.'"}/',$file,$tpl);
        }
      return $tpl;
    }

    //模块标签解析
    public function parBlock($param,$tpl)
    {
        //初始化模块样式缓存,创建缓存文件
        is_dir(RUN_TIME.'/block_cache')?null:mkdir(ROOT_PATH.'/runtime/block_cache',0777,true);//当缓存文件夹不存在就创建
        $baseName = RUN_TIME.'/block_cache/'.$GLOBALS['module'].'-'.$GLOBALS['controller'].'-'.$GLOBALS['action'];
        $cssCahce = $baseName.'.css';
        $jsCahce = $baseName.'.js';
        file_exists($cssCahce)?file_put_contents($cssCahce,'',FILE_USE_INCLUDE_PATH):null;
        file_exists($jsCahce)?file_put_contents($jsCahce,'',FILE_USE_INCLUDE_PATH):null;

        //初始化css,js缓存文件
        $cssCahce = $jsCahce = null;

        //初始化blockCache缓存文件
        $blockCache = RUN_TIME.'/block_cache';
        is_dir($blockCache)?null:mkdir($blockCache,0777,true);


        //循环处理参数
        foreach($param[0] as $k=>$v){
            $blockData ='';
            $blockStr = $param[0][$k];
            $paramArr = [$param[1][$k],$param[2][$k],$param[3][$k]];
            foreach ($paramArr as $pv){
                if(preg_match('/name="(\w+)"/',$pv,$p)){
                     $blockName = $p[1];
                }
                if(preg_match('/dir="(.+)"/',$pv,$p)){
                    $blockDir = $p[1];
                }
                if(preg_match('/data="([\s\S]*?)"/',$pv,$p)){
                    $blockData = $p[1];
                }
            }


            //模块路径
            $blockPath = ROOT_PATH.$blockDir.'/'.$blockName;
            file_exists($blockPath)?null:exit('ERROR:'.$blockPath.' 模块文件不存在');


            //加入模块数据
            $DataCode = '';
            if(!empty($blockData)){
                if(substr($blockData,0,1) == '$'){
                    $DataCode = '<?php $'.$blockName.'Data='.$blockData.'; ?>';
                }else{
                    $DataCode =  '<?php $'.$blockName.'Data = '.$blockData.' ?>';
                }
            }


            //替换为html文件
            $htmlPath = $blockPath.'/'.$blockName.'.html';
            $htmlCode = $DataCode."\n".file_get_contents($htmlPath);
            if(file_exists($htmlPath)){
                //$_patten =  '/'.$blockStr.'/';
                $tpl = str_replace($blockStr,$htmlCode,$tpl);
            }else{
                exit('ERROR:'.$htmlPath.' 模块html文件不存在');
            }


            //css文件
            $cssPath = $blockPath.'/'.$blockName.'.css';
            if(file_exists($cssPath)){
                //获取模块css文件
                $tips = '
/*模块 '.$blockName.'-------------------------------------------------------*/
';
                $cssFile =  $tips.file_get_contents($cssPath);
                //判断样式缓存文件是否存在
                $cssCahce = $blockCache.'/'.$GLOBALS['module'].'-'.$GLOBALS['controller'].'-'.$GLOBALS['action'].'.css';
                if(file_exists($cssCahce)){
                    //追加到模块css缓存中
                    if (!file_put_contents($cssCahce,$cssFile,FILE_APPEND)) {
                        exit('ERROR：模块缓存文件生成出错！');
                    }
                }else{
                    //生成模块缓存文件并追加css缓存
                    if (!file_put_contents($cssCahce,$cssFile)) {
                        exit('ERROR：模块缓存文件生成出错！');
                    }
                }
            }

            //js文件
            $jsPath = $blockPath.'/'.$blockName.'.js';
            if(file_exists($jsPath)){
                //获取模块css文件
                $tips = '
//模块 '.$blockName.'-------------------------------------------------------
';
                $jsFile = $tips.file_get_contents($jsPath);
                //判断样式缓存文件是否存在
                $jsCahce = $blockCache.'/'.$GLOBALS['module'].'-'.$GLOBALS['controller'].'-'.$GLOBALS['action'].'.js';
                if(file_exists($jsCahce)){
                    //追加到模块css缓存中
                    if (!file_put_contents($jsCahce,$jsFile,FILE_APPEND)) {
                        exit('ERROR：模块缓存文件生成出错！');
                    }
                }else{
                    //生成模块缓存文件并追加css缓存
                    if (!file_put_contents($jsCahce,$jsFile)) {
                        exit('ERROR：模块缓存文件生成出错！');
                    }
                }
            }
        }


        //引入合并后的js,css文件
        if(file_exists($cssCahce) && file_exists($jsCahce)){
            //判断当前是http:// 还是 https://
            is_https() ? $http_type ='https://' : $http_type ='http://';
            $blockCss =$http_type.DOMAIN.'/runtime/block_cache/'.$GLOBALS['module'].'-'.$GLOBALS['controller'].'-'.$GLOBALS['action'].'.css';
            $blockJs =$http_type.DOMAIN.'/runtime/block_cache/'.$GLOBALS['module'].'-'.$GLOBALS['controller'].'-'.$GLOBALS['action'].'.js';

            $_patten = '/<head>/';
            $blockCss = '<head>'."\n".'<link rel="stylesheet" type="text/css" href="'.$blockCss.'"/>';
            $tpl= preg_replace($_patten,$blockCss,$tpl,1);

            $_patten = '/<\/body>/';
            $blockJs = '</body>'."\n".'<script type="text/javascript" src="'.$blockJs.'"></script>';
            $tpl= preg_replace($_patten,$blockJs,$tpl,1);
        }

        return $tpl;

    }


    //解析只加载一次文件签
    public function parLoadOnce($param,$tpl){
        foreach($param[1] as $k=>$v){

            //js
            if(preg_match('/\.js$/',$v)){
                if(substr_count($tpl,'src="'.$v.'"')>=1){
                    $tpl= str_replace($param[0][$k],'',$tpl);
                }else{
                    $tpl= str_replace($param[0][$k],'<script type="text/javascript" src="'.$v.'"></script>',$tpl);

                }
            }

            //css
            if(preg_match('/\.css$/',$v)){
                if(substr_count($tpl,'href="'.$v.'"')>=1){
                    $tpl= str_replace($param[0][$k],'',$tpl);
                }else{
                    $tpl= str_replace($param[0][$k],'<link rel="stylesheet" type="text/css" href="'.$v.'"/>',$tpl);
                }
            }

        }
        return $tpl;
    }




    //其它标签解析，待修改





}
