<?php
namespace blockphp\lib\template;
use blockphp\lib\template\Parser;
//标签库类
class TagLib extends Parser
{


    private $_tpl;  //保存模板内容
    public function __construct($_tplFile) {
        if (!$this->_tpl = file_get_contents($_tplFile)) {
            exit('ERROR：模板文件读取错误！');
        }
    }


    //解析模版继承
    private function extend()
    {
        $_patten = '/\{extend name=[\'"]([\w\/]+)[\'"]\}/U';

        if(preg_match($_patten,$this->_tpl,$content)){
            $etpl = $this->parExtend($content[1],$this->_tpl);
            $this->_tpl = preg_replace($_patten,$etpl,$this->_tpl);
        }
        //清理模版 part 标签
        $_partPatten = '/\{part\s+name=[\'"]\w+[\'"]\}[\s\S]*?\{\/part\}/';
        $this->_tpl = preg_replace($_partPatten,'',$this->_tpl);
    }


	//解析普通变量{$name}
	private function vars()
    {
		$_patten = '/\{\$.+\}/U';
        if(preg_match_all($_patten,$this->_tpl,$content)){
            foreach ($content[0] as $k=>$v){
                $parStr =  $this->parVar($v);
                $this->_tpl = str_replace($v,$parStr,$this->_tpl);
            }
        }
	}

	//解析php标签{php}{/php}
    private function parPhp()
    {
        $_pattenPhp = '/\{php\}/';
        $_pattenEndPhp = '/\{\/php\}/';
        if(preg_match($_pattenPhp,$this->_tpl)){
	       if(preg_match($_pattenEndPhp,$this->_tpl)){
                $this->_tpl = preg_replace($_pattenPhp,"<?php ",$this->_tpl);
                $this->_tpl = preg_replace($_pattenEndPhp,"?>",$this->_tpl);
            }
        }
    }

    //循环输出标签{volist name="arrName" id="" empty="" key="" offset="" length=""}{/volist}
    private function parVolist()
    {
        $_pattenVolist = '/\{volist(.+)\}/U';
        $_pattenEndVolist = '/\{\/volist\}/';
        if(preg_match($_pattenVolist,$this->_tpl,$loopParam)){
            if(preg_match($_pattenEndVolist,$this->_tpl)){
                $loopParam = $loopParam[1]; //取得参数字符串
                $_data = array();$_item='item';$_key='key';$_empty='"无数据"';$_offset=0;$_length=0; $_i='i';//初始化数据
                //获取循环数据data
                if(preg_match('/name=\"([\w]+)\"/',$loopParam,$_dataRes)){
                    $_data = $_dataRes[1];
                }
                //获取循环项值
                if(preg_match('/id=\"([\w]+)\"/',$loopParam,$_itemRes)){
                    $_item = $_itemRes[1];
                }
                //获了键名key
                if(preg_match('/key=\"(.+)\"/U',$loopParam,$_keyRes)){
                    $_key = $_keyRes[1];
                }
                //获取空值empty
                if(preg_match('/empty=\"(.+)\"/U',$loopParam,$_emptyRes)){
                    $_empty = '"'.$_emptyRes[1].'"';
                }
                //获取起始行数offset，默认0
                if(preg_match('/offset=\"([\$\w]+)\"/',$loopParam,$_offsetRes)){
                    $_offset = $_offsetRes[1];
                }
                //获取输出长度length,默认null
                if(preg_match('/length=\"([\$\w]+)\"/',$loopParam,$_lengthRes)){
                   $_length = $_lengthRes[1];
                }
                //获取当前条数
                if(preg_match('/i=\"([\$\w]+)\"/',$loopParam,$_iRes)){
                    $_i = $_iRes[1];
                }

                $originObj = 'originObj'; //分页对象,用于存似原始分页对象

                //头尾替换
               $this->_tpl = preg_replace($_pattenVolist,"<?php  if(is_object($$_data)){ $$originObj =$$_data;  $$_data = $$_data".'->pageData'.";} foreach($$_data as $$_key=>$$_item):  $$_i= getKeyMap($$_data,$$_key);  if($$_i<$_offset){continue;}  if($_length !=0 && $$_i>=($_offset+$_length)){continue;}  ?>",$this->_tpl);
               $this->_tpl = preg_replace($_pattenEndVolist,"<?php endforeach; if(count($$_data) == 0){echo $_empty;}  if(isset($$originObj)){ $$_data = $$originObj;} ?>",$this->_tpl);

            }else{
                exit('ERROR：loop缺少闭合标签');
            }
        }
    }


	//解析if语句
    private function parIf()
    {
        $_pattenIf = '/\{if\s+condition=\"(.+)\"\}/U';
        $_pattenElseIf = '/\{elseif\s+condition=\"(.+)\"\}/U';
        $_pattenElse = '/\{else\}/';
        $_pattenEndIf = '/\{\/if\}/';
        if (preg_match($_pattenIf,$this->_tpl)){
            if (preg_match($_pattenEndIf,$this->_tpl)){
                $this->_tpl = preg_replace($_pattenIf,"<?php if($1): ?>",$this->_tpl);
                $this->_tpl = preg_replace($_pattenElseIf,"<?php elseif($1): ?>",$this->_tpl);
                $this->_tpl = preg_replace($_pattenElse,"<?php else: ?>",$this->_tpl);
                $this->_tpl = preg_replace($_pattenEndIf,"<?php endif; ?>",$this->_tpl);
            }else{
                exit('ERROR：if语句没有关闭！');
            }
        }
    }

	//解析include语句
	private function parInclude() {
		$_patten = '/\{include\s+file=\"([\w\.\-\/]+)\"\}/';
		if (preg_match($_patten,$this->_tpl,$_file)) {
			if (!file_exists(ROOT_PATH.$_file[1]) || empty($_file)) {
                echo 'ERROR：包含文件出错！';
			}
			$this->_tpl = preg_replace($_patten,"<?php include ROOT_PATH.'$1';?>",$this->_tpl);
		}
	}
	
	//PHP代码注释
	private function parCommon() {
		$_patten = '/\{#\}(.*)\{#\}/';
		if (preg_match($_patten,$this->_tpl)) {
			$this->_tpl = preg_replace($_patten,"<?php /* $1 */?>",$this->_tpl);
		}
	}

    //php 输出
    private function parEcho(){
        $_patten = '/\{:([\s\S]*?)\}/';
        if (preg_match($_patten,$this->_tpl)) {
            $this->_tpl = preg_replace($_patten,"<?php echo $1;?>",$this->_tpl);
        }
    }

	//解析模块标签
	private function block() {
		//匹配到模块标签，存入数数$blockTag
		$_patten = '/{block\s*(name="\w+")\s*(dir="[\/\w]+")\s*(data="[\s\S]*?")?\s*}/';
		if(preg_match_all($_patten,$this->_tpl,$param)){
            $this->_tpl = $this->parBlock($param,$this->_tpl);
		}
	}

    //模版引入标签,默认模版路径指向当前模型下的view文件夹
    private function template()
    {
        $_parTemplate = '/\{template\s+\"([\w\.\/-]+)\"}/';
        if (preg_match_all($_parTemplate,$this->_tpl,$templateParam)){
            $this->_tpl = $this->parTemplate($templateParam[1],$this->_tpl);
        }
    }

    //全局字符串替换
    private function replaceStr(){

        $this->_tpl = $this->parReplaceStr($GLOBALS['config']['view_replace_str'],$this->_tpl);
    }

    //同一文件只加载一次标签
    private function loadOnce(){
        $_parLoadOnce = '/\{loadOnce\s+path=\"([\w\.\:\/-]+)\"}/';
        if (preg_match_all($_parLoadOnce,$this->_tpl,$content)){
            $this->_tpl = $this->parLoadOnce($content,$this->_tpl);
        }
    }



	//对外公共方法
	public function compile($_parFile,$_parFolderPath) {
		//解析模板内容
        $this->extend(); //模版继承
        $this->template(); //解析模版标签
		$this->block(); //解析block魔块
        $this->parInclude(); //解析include文件引入
        $this->parVolist(); //解析volist循环
		$this->parIf(); //解析if判断标签
        $this->parPhp(); //解析写入原生php
		$this->parCommon(); //php注释
        $this->parEcho(); //解析系统常量
        $this->vars(); //解析普通变量
        $this->replaceStr(); //全局字符串替换
        $this->loadOnce(); //一文件只加载一次标签
		
		
		//生成编译文件夹
		is_dir($_parFolderPath)?null:mkdir($_parFolderPath,0777,true);
		//生成编译文件
		if (!file_put_contents($_parFile, $this->_tpl)) {
			exit('ERROR：编译文件生成出错！');
		}
	}
	
}



