<?php
/**
 * 全局模块配置文件
 * 数使用数组格式
 */

defined('IN_MK') or exit('Access Denied');
return [

    // +----------------------------------------------------------------------
    // | 是否开启静态缓存
    // +----------------------------------------------------------------------
    'request_cache' => false,

    // +----------------------------------------------------------------------
    // | 缓存设置
    // +----------------------------------------------------------------------

    'cache'                  => [
        // 驱动方式
        'type'   => 'File',
        // 缓存保存目录
        'path'   => CACHE_PATH,
        // 缓存前缀
        'prefix' => '',
        // 缓存有效期 0表示永久缓存
        'expire' => 0,
    ],


    // + -----------------------------------------------------------------------------
    // | 分页配置
    // + -----------------------------------------------------------------------------
    'paginate'      => [
        'list_rows' => 8,            //分页数字的长度
        'prveText'  => '上一页',     //上一页文本
        'nextText'  => '上一页',     //下一页文本
        'ellipsis'  => '...'        //缩略字符
    ],


    // + -----------------------------------------------------------------------------
    // | 路由配置
    // + -----------------------------------------------------------------------------
    'route'       =>[
        'url_route_on'           => true,  // 是否开启路由
        'url_route_must'         => false, // 是否强制使用路由
    ],

    // + -----------------------------------------------------------------------------
    // | 模版输出替换
    // + -----------------------------------------------------------------------------
    'view_replace_str'  =>  [],


    // + -----------------------------------------------------------------------------
    // | 返回ajax请求数据格式
    // + -----------------------------------------------------------------------------
    'DEFAULT_AJAX_RETURN'=>'JSON'

];


